using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Collections.Specialized;

namespace LesDictionnaires
{
   public static class CollectionsNonGenericsDemo
    {
       public static void Execute()
       {
           long tempsD = DateTime.Now.Ticks;
           long tempsF = DateTime.Now.Ticks;

           Hashtable hash = new Hashtable(10000);
           ListDictionary list = new ListDictionary();

           tempsD = DateTime.Now.Ticks;

           for (int i = 0; i < 10000; i++)
           {
               hash.Add(i, i);
           }

           tempsF = DateTime.Now.Ticks;

           Console.WriteLine("Le temps mis pour insrer 10000 lments dans une Hashtable est {0}", tempsF - tempsD);
           //Le temps mis pour insrer 10000 lments dans une Hashtable est 40000

           tempsD = DateTime.Now.Ticks;

           for (int i = 0; i < 10000; i++)
           {
               list.Add(i, i);
           }

           tempsF = DateTime.Now.Ticks;

           Console.WriteLine("Le temps mis pour insrer 10000 lments dans une ListDictionary est {0}", tempsF - tempsD);
           //Le temps mis pour insrer 10000 lments dans une ListDictionary est 6720000

           Console.ReadKey();

           /********** Test Dictionary et ListDictionary : Cas de classes personnalises : Dictionary est plus rapide **************/

           list.Clear();

           Dictionary<PiloteEquatable, string> lesPilotes = new Dictionary<PiloteEquatable, string>(10);

           tempsD = DateTime.Now.Ticks;
           lesPilotes.Add(new PiloteEquatable("Fernando", "Alonso"), "McLaren Mercedes");
           lesPilotes.Add(new PiloteEquatable("Felipe", "Massa"), "Ferrari");
           lesPilotes.Add(new PiloteEquatable("Kimi", "Rikknen"), "Ferrari");
           lesPilotes.Add(new PiloteEquatable("Nick", "Heidfeld"), "BMW Sauber");
           lesPilotes.Add(new PiloteEquatable("Robert", "Kubica"), "BMW Sauber");
           lesPilotes.Add(new PiloteEquatable("Giancarlo", "Fisichella"), "Renault");
           lesPilotes.Add(new PiloteEquatable("Heikki", "Kovalainen"), "Renault");
           lesPilotes.Add(new PiloteEquatable("Alexander", "Wurz"), "Williams");
           lesPilotes.Add(new PiloteEquatable("Mark", "Webber"), "Red Bull");
           tempsF = DateTime.Now.Ticks;

           Console.WriteLine("Le temps mis pour insrer 10 lments dans une Dictionary est {0}", tempsF - tempsD);
           //Le temps mis pour insrer 10 lments dans une Dictionary est 30000

           tempsD = DateTime.Now.Ticks;
           list.Add(new PiloteEquatable("Fernando", "Alonso"), "McLaren Mercedes");
           list.Add(new PiloteEquatable("Felipe", "Massa"), "Ferrari");
           list.Add(new PiloteEquatable("Kimi", "Rikknen"), "Ferrari");
           list.Add(new PiloteEquatable("Nick", "Heidfeld"), "BMW Sauber");
           list.Add(new PiloteEquatable("Robert", "Kubica"), "BMW Sauber");
           list.Add(new PiloteEquatable("Giancarlo", "Fisichella"), "Renault");
           list.Add(new PiloteEquatable("Heikki", "Kovalainen"), "Renault");
           list.Add(new PiloteEquatable("Alexander", "Wurz"), "Williams");
           list.Add(new PiloteEquatable("Mark", "Webber"), "Red Bull");
           tempsF = DateTime.Now.Ticks;

           Console.WriteLine("Le temps mis pour insrer 10 lments dans une ListDictionary est {0}", tempsF - tempsD);
           //Le temps mis pour insrer 10 lments dans une List est 890000

           /********** Test Dictionary et ListDictionary : Cas de types simples **************/

           list.Clear();

           Dictionary<string, string> lesPilotesString = new Dictionary<string, string>(10);

           tempsD = DateTime.Now.Ticks;
           lesPilotesString.Add("L. Hamilton", "McLaren Mercedes");
           lesPilotesString.Add("F. Alonso", "McLaren Mercedes");
           lesPilotesString.Add("F. Massa", "Ferrari");
           lesPilotesString.Add("K. Rikknen", "Ferrari");
           lesPilotesString.Add("N. Heidfeld", "BMW Sauber");
           lesPilotesString.Add("R. Kubica", "BMW Sauber");
           lesPilotesString.Add("G. Fisichella", "Renault");
           lesPilotesString.Add("H. Kovalainen", "Renault");
           lesPilotesString.Add("A. Wurz", "Williams");
           lesPilotesString.Add("M. Webber", "Red Bull");
           tempsF = DateTime.Now.Ticks;

           Console.WriteLine("Le temps mis pour insrer 10 lments dans une Dictionary est {0}", tempsF - tempsD);
           //Le temps mis pour insrer 10 lments dans une Dictionary est 0

           tempsD = DateTime.Now.Ticks;
           list.Add("L. Hamilton", "McLaren Mercedes");
           list.Add("F. Alonso", "McLaren Mercedes");
           list.Add("F. Massa", "Ferrari");
           list.Add("K. Rikknen", "Ferrari");
           list.Add("N. Heidfeld", "BMW Sauber");
           list.Add("R. Kubica", "BMW Sauber");
           list.Add("G. Fisichella", "Renault");
           list.Add("H. Kovalainen", "Renault");
           list.Add("A. Wurz", "Williams");
           list.Add("M. Webber", "Red Bull");
           tempsF = DateTime.Now.Ticks;

           Console.WriteLine("Le temps mis pour insrer 10 lments dans une List est {0}", tempsF - tempsD);
           //Le temps mis pour insrer 10 lments dans une List est 0

           Console.ReadKey();
       }
    }
}
