using System;
using System.Collections.Generic;
using System.Text;

namespace LesDictionnaires
{
    public static class DictionaryDemo
    {
        public static void Execute()
        {
            //Initialiser la taille pour gagner en performance.
            Dictionary<string, string> lesPilotes = new Dictionary<string, string>(10);

            //Initialiser le dictionnaire
            lesPilotes.Add("L. Hamilton", " McLaren Mercedes");
            lesPilotes.Add("F. Alonso", " McLaren Mercedes");
            lesPilotes.Add("F. Massa", "Ferrari");
            lesPilotes.Add("K. Rikknen", "Ferrari");
            lesPilotes.Add("N. Heidfeld", "BMW Sauber");
            lesPilotes.Add("R. Kubica", "BMW Sauber");
            lesPilotes.Add("G. Fisichella", "Renault");
            lesPilotes.Add("H. Kovalainen", "Renault");
            lesPilotes.Add("A. Wurz", "Williams");
            lesPilotes.Add("M. Webber", "Red Bull");

            //lesPilotes.

            Afficher(lesPilotes);
            // 1 - Pilote : L. Hamilton , Ecurie :  McLaren Mercedes
            // 2 - Pilote : F. Alonso , Ecurie :  McLaren Mercedes
            // 3 - Pilote : F. Massa , Ecurie : Ferrari
            // 4 - Pilote : K. Rikknen , Ecurie : Ferrari
            // 5 - Pilote : N. Heidfeld , Ecurie : BMW Sauber
            // 6 - Pilote : R. Kubica , Ecurie : BMW Sauber
            // 7 - Pilote : G. Fisichella , Ecurie : Renault
            // 8 - Pilote : H. Kovalainen , Ecurie : Renault
            // 9 - Pilote : A. Wurz , Ecurie : Williams
            // 10 - Pilote : M. Webber , Ecurie : Red Bull

            //Exception "ArgumentNullException" leve lors de l'ajout d'une cl nulle
            try
            {
                lesPilotes.Add(null, "Ferrari");
            }
            catch (ArgumentNullException ex)
            {
                Console.WriteLine(System.Environment.NewLine + ex.Message);
                //Value cannot be null.
                //Parameter name: key
            }

            //l'ajout d'une valeur null autoris
            lesPilotes.Add("M. Fekih", null);

            //Exception "ArgumentException" leve lors de l'ajout d'une cl existante
            try
            {
                lesPilotes.Add("L. Hamilton", " McLaren Mercedes");
            }
            catch (ArgumentException ex)
            {

                Console.WriteLine(System.Environment.NewLine + ex.Message + System.Environment.NewLine);
                //An item with the same key has already been added.
            }

            //Supprimer des entres
            lesPilotes.Remove("K. Rikknen");
            lesPilotes.Remove("G. Fisichella");

            //Afficher les les pilotes
            Afficher(lesPilotes);

            // 1 - Pilote : L. Hamilton , Ecurie :  McLaren Mercedes
            // 2 - Pilote : F. Alonso , Ecurie :  McLaren Mercedes
            // 3 - Pilote : F. Massa , Ecurie : Ferrari
            // 4 - Pilote : N. Heidfeld , Ecurie : BMW Sauber
            // 5 - Pilote : R. Kubica , Ecurie : BMW Sauber
            // 6 - Pilote : H. Kovalainen , Ecurie : Renault
            // 7 - Pilote : A. Wurz , Ecurie : Williams
            // 8 - Pilote : M. Webber , Ecurie : Red Bull
            // 9 - Pilote : M. Fekih , Ecurie :

        }



        public static void ExecuteIEquatable()
        {
            Dictionary<Pilote, string> lesPilotes = new Dictionary<Pilote, string>(3);

            //Essayer d'inserer deux pilotes identiques sans l'implementation de IEquatable
            lesPilotes.Add(new Pilote("Lewis", "Hamilton"), " McLaren Mercedes");
            lesPilotes.Add(new Pilote("Fernando", "Alonso"), " McLaren Mercedes");
            lesPilotes.Add(new Pilote("Lewis", "Hamilton"), " McLaren Mercedes");

            //1 - Pilote : Lewis Hamilton , Ecurie :  McLaren Mercedes
            //2 - Pilote : Fernando Alonso , Ecurie :  McLaren Mercedes
            //3 - Pilote : Lewis Hamilton , Ecurie :  McLaren Mercedes

            //a fonctionne ; le dictionnaire ne detecte pas le mme pilote
            Afficher(lesPilotes);

            Dictionary<PiloteEquatable, string> lesPilotesEquatable = new Dictionary<PiloteEquatable, string>(5);

            lesPilotesEquatable.Add(new PiloteEquatable("Lewis", "Hamilton"), " McLaren Mercedes");
            lesPilotesEquatable.Add(new PiloteEquatable("Fernando", "Alonso"), " McLaren Mercedes");

            try
            {
                lesPilotesEquatable.Add(new PiloteEquatable("Lewis", "Hamilton"), " McLaren Mercedes");
            }
            catch (ArgumentException ex)
            {
                Console.WriteLine(System.Environment.NewLine + ex.Message);

                //GetHashCode appel
                //GetHashCode appel

                //Le dictionnaire detecte deux hashcode identitiques => GetHashCode appel
                //Il va donc comparer les instaces grce  Equals => Equals appel

                //An item with the same key has already been added.
            }


            Console.WriteLine(lesPilotesEquatable.ContainsKey(new PiloteEquatable("Fernando", "Alonso"))); // True

            lesPilotesEquatable.Remove(new PiloteEquatable("Fernando", "Alonso"));
        }


        private static void Afficher(Dictionary<string, string> lesPilotes)
        {
            int index = 1;
            foreach (KeyValuePair<string, string> pilote in lesPilotes)
            {
                Console.WriteLine(" {0} - Pilote : {1} , Ecurie : {2}", index++, pilote.Key, pilote.Value);
            }

            Console.WriteLine();
        }

        private static void Afficher(Dictionary<Pilote, string> lesPilotes)
        {
            int index = 1;
            foreach (KeyValuePair<Pilote, string> pilote in lesPilotes)
            {
                Console.WriteLine(" {0} - Pilote : {1} , Ecurie : {2}", index++, pilote.Key, pilote.Value);
            }

            Console.WriteLine();
        }
    }
}
