using System;
using System.Collections.Generic;
using System.Text;

namespace LesDictionnaires
{
public static class KeyedCollectionDemo
{
    public static void Execute()
    {
        PiloteKeyedCollection lesPilotes = new PiloteKeyedCollection();

        lesPilotes.Add(new Pilote("Lewis", "Hamilton"));
        lesPilotes.Add(new Pilote("Fernando", "Alonso"));

        try
        {
            lesPilotes.Add(new Pilote("Fernando", "Alonso"));
            //An item with the same key has already been added.
        }
        catch (ArgumentException ex)
        {
            Console.WriteLine(ex.Message);
        }

        lesPilotes.Add(new Pilote("Felipe", "Massa"));
        lesPilotes.Add(new Pilote("Kimi", "Rikknen"));
        lesPilotes.Add(new Pilote("Nick", "Heidfeld"));
        lesPilotes.Add(new Pilote("Robert", "Kubica"));
        lesPilotes.Add(new Pilote("Giancarlo", "Fisichella"));
        lesPilotes.Add(new Pilote("Heikki", "Kovalainen"));
        lesPilotes.Add(new Pilote("Alexander", "Wurz"));
        lesPilotes.Add(new Pilote("Mark", "Webber"));

        //Lewis Hamilton
        //Fernando Alonso
        //Felipe Massa
        //Kimi Rikknen
        //Nick Heidfeld
        //Robert Kubica
        //Giancarlo Fisichella
        //Heikki Kovalainen
        //Alexander Wurz
        //Mark Webber

        Afficher(lesPilotes);

        Console.ReadKey();

        Console.WriteLine("Le pilote Lewis Hamilton appartient-il  la collection ? : {0}", lesPilotes.Contains("Lewis Hamilton"));
        //Le pilote Lewis Hamilton appartient-il  la collection ? : True

        Console.ReadKey();

        //insertion indexe
        lesPilotes.Insert(0, new Pilote("David", "Coulthard"));

        lesPilotes.RemoveAt(10);

        //affichage par index
        AfficherParIndex(lesPilotes);
        //David Coulthard
        //Lewis Hamilton
        //Fernando Alonso
        //Felipe Massa
        //Kimi Rikknen
        //Nick Heidfeld
        //Robert Kubica
        //Giancarlo Fisichella
        //Heikki Kovalainen
        //Alexander Wurz

        Console.ReadKey();

    }

    private static void Afficher(PiloteKeyedCollection lesPilotes)
    {
        Console.WriteLine();
        foreach (Pilote pilote in lesPilotes)
        {
            Console.WriteLine(pilote);
        }
        Console.WriteLine();
    }

    private static void AfficherParIndex(PiloteKeyedCollection lesPilotes)
    {
        Console.WriteLine();

        for (int i = 0; i < lesPilotes.Count; i++)
        {
            Console.WriteLine(lesPilotes[i]);
        }
        Console.WriteLine();
    }
}
}
