using System;
using System.Collections.Generic;
using System.Text;

namespace LesDictionnaires
{
    public static class SortedDictionaryDemo
    {
        public static void Execute()
        {
            SortedDictionary<string,string> lesPilotes=new SortedDictionary<string,string>();

            lesPilotes.Add("L. Hamilton", "McLaren Mercedes");
            lesPilotes.Add("F. Alonso", "McLaren Mercedes");
            lesPilotes.Add("F. Massa", "Ferrari");
            lesPilotes.Add("K. Rikknen", "Ferrari");
            lesPilotes.Add("N. Heidfeld", "BMW Sauber");
            lesPilotes.Add("R. Kubica", "BMW Sauber");
            lesPilotes.Add("G. Fisichella", "Renault");
            lesPilotes.Add("H. Kovalainen", "Renault");
            lesPilotes.Add("A. Wurz", "Williams");
            lesPilotes.Add("M. Webber", "Red Bull");

            Afficher(lesPilotes);
             //1 - Pilote : A. Wurz , Ecurie : Williams
             //2 - Pilote : F. Alonso , Ecurie : McLaren Mercedes
             //3 - Pilote : F. Massa , Ecurie : Ferrari
             //4 - Pilote : G. Fisichella , Ecurie : Renault
             //5 - Pilote : H. Kovalainen , Ecurie : Renault
             //6 - Pilote : K. Rikknen , Ecurie : Ferrari
             //7 - Pilote : L. Hamilton , Ecurie : McLaren Mercedes
             //8 - Pilote : M. Webber , Ecurie : Red Bull
             //9 - Pilote : N. Heidfeld , Ecurie : BMW Sauber
             //10 - Pilote : R. Kubica , Ecurie : BMW Sauber
        }

        public static void ExecuteIEquatable()
        {
            SortedDictionary<PiloteComparable, string> lesPilotes = new SortedDictionary<PiloteComparable, string>();

            //Dans le cas d'une classe personnalise, il faut imprativement implementer IComparable
            lesPilotes.Add(new PiloteComparable("Lewis", "Hamilton"), "McLaren Mercedes");


            //la duplication est detecte par CompareTo et non pas par Equals et GetHashCode
            try
            {
                lesPilotes.Add(new PiloteComparable("Lewis", "Hamilton"), "McLaren Mercedes");
            }
            catch (ArgumentException ex)
            {

                Console.WriteLine(System.Environment.NewLine + ex.Message + System.Environment.NewLine);
                //An entry with the same key already exists.
            }

            lesPilotes.Add(new PiloteComparable("Fernando", "Alonso"), "McLaren Mercedes");
            lesPilotes.Add(new PiloteComparable("Felipe", "Massa"), "Ferrari");
            lesPilotes.Add(new PiloteComparable("Kimi", "Rikknen"), "Ferrari");
            lesPilotes.Add(new PiloteComparable("Nick", "Heidfeld"), "BMW Sauber");
            lesPilotes.Add(new PiloteComparable("Robert", "Kubica"), "BMW Sauber");
            lesPilotes.Add(new PiloteComparable("Giancarlo", "Fisichella"), "Renault");
            lesPilotes.Add(new PiloteComparable("Heikki", "Kovalainen"), "Renault");
            lesPilotes.Add(new PiloteComparable("Alexander", "Wurz"), "Williams");
            lesPilotes.Add(new PiloteComparable("Mark", "Webber"), "Red Bull");

            Afficher(lesPilotes);
            //1 - Pilote : Alexander Wurz , Ecurie : Williams
            //2 - Pilote : Felipe Massa , Ecurie : Ferrari
            //3 - Pilote : Fernando Alonso , Ecurie : McLaren Mercedes
            //4 - Pilote : Giancarlo Fisichella , Ecurie : Renault
            //5 - Pilote : Heikki Kovalainen , Ecurie : Renault
            //6 - Pilote : Kimi Rikknen , Ecurie : Ferrari
            //7 - Pilote : Lewis Hamilton , Ecurie : McLaren Mercedes
            //8 - Pilote : Mark Webber , Ecurie : Red Bull
            //9 - Pilote : Nick Heidfeld , Ecurie : BMW Sauber
            //10 - Pilote : Robert Kubica , Ecurie : BMW Sauber


            //ContainsKey utilise que CompareTo 
            Console.WriteLine(lesPilotes.ContainsKey(new PiloteComparable("Robert", "Kubica")));
            //True

            //Remove utilise que CompareTo
            lesPilotes.Remove(new PiloteComparable("Giancarlo", "Fisichella"));

            Console.WriteLine(Environment.NewLine + lesPilotes[new PiloteComparable("Mark", "Webber")]);
            //Red Bull
        }


        private static void Afficher(SortedDictionary<string, string> lesPilotes)
        {
            int index = 1;
            foreach (KeyValuePair<string, string> pilote in lesPilotes)
            {
                Console.WriteLine(" {0} - Pilote : {1} , Ecurie : {2}", index++, pilote.Key, pilote.Value);
            }

            Console.WriteLine();
        }


        private static void Afficher(SortedDictionary<PiloteComparable, string> lesPilotes)
        {
            int index = 1;
            foreach (KeyValuePair<PiloteComparable, string> pilote in lesPilotes)
            {
                Console.WriteLine(" {0} - Pilote : {1} , Ecurie : {2}", index++, pilote.Key, pilote.Value);
            }

            Console.WriteLine();
        }

    }
}
